Subject: bug#25247: 26.0.50; Concurrency crashes with XLib

From: Eli Zaretskii <[email-masked]>
Date: Fri, 30 Dec 2016 13:05:46 +0200

> From: Elias Mårtenson <[email-masked]>
> Date: Fri, 30 Dec 2016 18:30:05 +0800
> Cc: Tino Calancha <[email-masked]>, [email-masked], [email-masked]
> 
> The C-g issue is still gone.
> 
> As for the concurrency issues. I have been hammering this thing pretty
> hard, and no crashes so far.

Thanks, this is good news.

> I open IELM in one window, and an empty buffer "z" in another, and type the
> following:
> 
> (loop
>   repeat 10
>   do (make-thread (lambda ()
>                     (let ((n (random 10)))
>                       (with-current-buffer "z"
>                         (sleep-for n)
>                         (insert (format "Foo:%d\n" n)))))))
> 
> Here, I'd expect to see the "z" buffer being updated at the corresponding
> times. I.e. the message "Foo:4" should be displayed after 4 seconds. This
> is not what I see. Instead the messages appear in batches (i.e. several
> rows appearing at the same time).

And what do the messages that appear together say in the %d part?  Do
they all show the same value?

> The following seems to be a problem with lexically bound lambda functions
> used in a thread. The following example illustrates the problem:
> 
> (let ((x "test"))
>   (make-thread (lambda ()
>                  (with-current-buffer "z"
>                    (insert x)))))
> 
> I would expect this to insert "test" into the buffer, but instead nothing
> happens. Removing the reference to the variable "x" in the lambda makes it
> work.

Isn't the above expected?  If not, why not?

And what do you mean by "removing the reference"?